const { validateToken } = require('./utils');


module.exports = {
    name: 'auth',
    policy: (actionParams) => {
        return (req, res, next) => {
            const email = req.header('x-user-email');
            const token = req.get('x-user-token');

            validateToken(token).then(result => {
                if (!result.error) {
                    next();
                } else {
                    res.header("Access-Control-Allow-Origin", "*");
                    res.status(401).json({
                        status: 'error',
                        message: 'Token expired',
                    });
                }
            }).catch((error) => {
                if (!error.err) {
                    console.error('[api-gateway] Token invalid');
                } else {
                    console.error(error);
                }
                res.header("Access-Control-Allow-Origin", "*");
                res.status(401).json({
                    status: 'error',
                    message: 'Token expired',
                });
            });
        };
    }
};
