#!/usr/bin/env bash
RTLS_API_GATEWAY_PREFIX=/usr/rtls/rtls-api-gateway

mkdir -p /etc/nginx/sites-enabled
mkdir -p /etc/nginx/sites-available

## Create rtls-api-gateway.service file
if [ -e $RTLS_API_GATEWAY_PREFIX/sys-services/rtls-api-gateway.service ]; then
  cp $RTLS_API_GATEWAY_PREFIX/sys-services/rtls-api-gateway.service /usr/lib/systemd/system
  chmod 644 /usr/lib/systemd/system/rtls-api-gateway.service
  chown ubuntu:ubuntu /usr/lib/systemd/system/rtls-api-gateway.service
fi

systemctl enable rtls-api-gateway

## Create rtls-api-gateway.nginx file
if [ -e /etc/nginx/sites-available/rtls-api-gateway.nginx ]; then
  rm -rf /etc/nginx/sites-available/rtls-api-gateway.nginx
fi

if [ -e /etc/nginx/sites-enabled/rtls-api-gateway.nginx ]; then
  rm -rf /etc/nginx/sites-enabled/rtls-api-gateway.nginx
fi

cp $RTLS_API_GATEWAY_PREFIX/sys-services/rtls-api-gateway.nginx /etc/nginx/sites-available
ln -sf /etc/nginx/sites-available/rtls-api-gateway.nginx /etc/nginx/sites-enabled/

sudo nginx -s reload

service rtls-api-gateway start

exit 0
